[Leetcode] 377. Combination Sum IV 解题报告

来源:互联网 发布:mac air 装单win详细 编辑:程序博客网 时间:2024/06/05 03:39

题目

Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.

Example:

nums = [1, 2, 3]target = 4The possible combination ways are:(1, 1, 1, 1)(1, 1, 2)(1, 2, 1)(1, 3)(2, 1, 1)(2, 2)(3, 1)Note that different sequences are counted as different combinations.Therefore the output is 7.

Follow up:
What if negative numbers are allowed in the given array?
How does it change the problem?
What limitation we need to add to the question to allow negative numbers?

思路

一道典型的动态规划题目(是不是感觉和背包问题很像?)。我们定义dp[i]表示给定nums后,和为i的时候有多少种排列方式,这样状态转移方程就是:dp[i] = sum(dp[i - nums[j]]),其中i - nums[j] >= 0。该算法的空间复杂度是O(target),时间复杂度是O(target * n),其中n是数组的长度。

如果允许负数存在,则问题的解有可能为无穷大,例如如果数组中有元素1,-1,那么这两个数字可以出现无限次。因此为了得到有限解我们就必须要限制每个数能用的最大次数了。

代码

class Solution {public:    int combinationSum4(vector<int>& nums, int target) {        sort(nums.begin(), nums.end());        vector<int> dp(target + 1, 0);        dp[0] = 1;        for (int i = 1; i <= target; ++i) {            for (int j = 0; j < nums.size(); ++j) {                if (nums[j] > i) {                    break;                }                dp[i] += dp[i - nums[j]];            }        }        return dp[target];    }};